#ifndef MODELGRID_H
#define MODELGRID_H

#include <vector.h>
#include <iostream>
#include <string>

class datagrid;

using namespace std;

class modelgrid{
 public:
  modelgrid();
  modelgrid(int nx_new);
  double get_data(string name,int i,int j);
  vector<double> get_data(string name);
  void set_psi(int i, int j,double val);
  void set_psi(vector<double> valarray);
  void update_all();
  void update_kappa();
  void update_gamma();
  void update_ellipticity();
  void update_flexion();
  double chi2(datagrid d);
  int get_nx() {return nx;};
  int get_ny() {return ny;};
  int get_index(string name ,int i,int j);
  void set_reg_type(string reg_type_new){reg_type=reg_type_new;};
  void set_eta(double eta_new) {eta=eta_new;};
  void set_b(vector<double> b_new) {b=b_new;};
  vector<double> get_b() {return b;};
  string get_reg_type() {return(reg_type);};
  modelgrid refine(int ismooth=0);
  void fit_b();
  void create_matrix();
  void set_data(datagrid d);
  vector<double> psi_newton_grid();
  vector<vector<double> > get_arr(string name);
 private:
  int nx,ny;
  int n,NN;
  
  vector<vector<double> > K_arr;
  vector<vector<double> > G1_arr;
  vector<vector<double> > G2_arr;
  vector<double> psi;
  vector<double> w;
  vector<double> kappa;
  vector<double> gamma1;
  vector<double> gamma2;
  vector<double> F1;
  vector<double> F2;
  vector<double> e1;
  vector<double> e2;
  vector<double> e1_data;
  vector<double> e2_data;
  double eta; // The regularization parameter
  vector<double> b; // The regularlization normalization
  string reg_type;
              // Currently supported: 
              /*
		ME - Maximum Entropy from Seitz, 
		Schneider & Bartelmann, eq 8, 9
		NONE
	      */
};

#endif
